/*
 * Proyecto: Error_TPicture
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 30/08/2017
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oButton_Proceso
   COMPONENT oButton_Parar
   COMPONENT oLabel_Contador
   COMPONENT oCheckbox_ForzarGDI

   DATA  lPararProceso        INIT  .F.
   DATA  nImagenesProcesadas  INIT  0

   METHOD CreateForm()
   METHOD FormInitialize( oSender )

   METHOD Button_Proceso__Click( oSender )
   METHOD Button_Parar__Click( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1

   ::oButton_Proceso:lEnabled := .T.
   ::oButton_Parar:lEnabled   := .F.

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button_Proceso__Click( oSender ) CLASS TForm1

   LOCAL oPicture
   LOCAL cImagen

   LOCAL cImagenInicial
   LOCAL cImagenDestino


   cImagenInicial := Application:cDirectory + "ImgInicial.jpg"
   cImagenDestino := Application:cDirectory + "ImgDestino.jpg"

   ::oButton_Proceso:lEnabled := .F.
   ::oButton_Parar:lEnabled   := .T.

   ::lPararProceso := .F.

   DO WHILE .T.

      IF ::lPararProceso
         EXIT
      ENDIF

      oPicture := TPicture():LoadFromFile( cImagenInicial, , ::oCheckbox_ForzarGDI:lChecked )

      cImagen := oPicture:MakeThumbnail( Int( oPicture:nWidth / 2 ), ;
         Int( oPicture:nHeight / 2 ), ;
         Nil, ;
         100 )

      oPicture:LoadFromStream( cImagen, ::oCheckbox_ForzarGDI:lChecked )

      oPicture:Save( cImagenDestino )

      oPicture:End()
      oPicture:Destroy()
      oPicture:Free()
      oPicture := ""

      ::nImagenesProcesadas := ::nImagenesProcesadas + 1
      ::oLabel_Contador:cText := "Nmero de veces procesada la imagen: " + Str( ::nImagenesProcesadas )

      ProcessMessages()

   ENDDO

   ::oButton_Proceso:lEnabled := .T.
   ::oButton_Parar:lEnabled   := .F.

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button_Parar__Click( oSender ) CLASS TForm1

   ::lPararProceso := .T.

RETURN Nil

//------------------------------------------------------------------------------
